<?php

class Config {

    private $key;
    public $activation;

    public function __construct (){
$dbpassword="amodifier";
        $dbport="3306";
        %if %%getVar("balado_db_mode", 'non') == "externe"
        $dbhost="%%balado_dbserver";
            %if %%getVar('balado_dbport', 'non') != "non"
        $dbport="%%balado_dbport";
            %end if
        %else if %%getVar("balado_db_mode", 'non') == "default"
           %set dbhost = %%getVar('edb_host', 'non')
           %if %%dbhost == 'non' and %%mode_conteneur_actif == 'oui':
        $dbhost="%%adresse_ip_mysql";
           %else
               %if %%dbhost == 'non'
        $dbhost="localhost";
               %else
        $dbhost="%%edb_host";
               %end if
           %end if
    
           %if %%getVar('edb_dbport', 'non') != "non"
        $dbport="%%edb_port";
            %end if
        %else
        $dbhost="%%adresse_ip_mysql";
        %end if

        $this->jwt=array(
            'key'       => 'kqG5TYtnnjMDBIKqGqbJqYuZNUPFOuWdVjqM9GWm5QLJ2rPE9uj3msnarymoRgaWx4+UJmPzSmyCREWxYKDytA==',     // Key for signing the JWT's, I suggest generate it with base64_encode(openssl_random_pseudo_bytes(64))
            'algorithm' => 'HS512' // Algorithm used to sign the token, see https://tools.ietf.org/html/draft-ietf-jose-json-web-algorithms-40#section-3
            );

        $conf=parse_ini_file ("config.ini",TRUE);

        $this->api_key='%%pwdreader("","/var/www/html/balado/.key")';        
        $this->version='envole';
        $this->serverName='localhost';
        $this->restUrl='https://%%web_url/balado/rest/';
        $this->restUrlOld='https://%%web_url/balado/rest/';
        $this->appUrl='https://%%web_url/balado/app/';
        //$this->etabUrl='https://balado.ac-creteil.fr/baladoetab/';
        //$this->acad="ac-creteil.fr";
        $this->pathFfmpeg="/usr/bin/";
        $this->pathServer="/var/www/html/balado/rest/";
        $this->maxfilesize=$conf['filemaxsize'];
        $this->extensions=$conf['extensions'];
        /*
        $this->dep=array('77'=>"ac-creteil.fr",
                        '94'=>"ac-creteil.fr",
                        '93'=>"ac-creteil.fr",
                        '46'=>"ac-toulouse.fr"
                        );
        */

        $this->cas=[
            "itslearning"=> [
                "adresse"=>"cas.itslearning.com",
                "port"=>"443",
                "contexte"=>"cas-creteil",
                "type"=>"itslearning",
            ],
            "envole"=> [
                "adresse"=>"%%eolesso_adresse",
                "port"=>"%%eolesso_port",
                "contexte"=>"",
                "type"=>"envole",
            ],
            "ent77"=> [
                "adresse"=>"ent77.seine-et-marne.fr",
                "port"=>"443",
                "contexte"=>"cas",
                "type"=>"ent77",
            ],
            "monlycee"=>[
                "adresse"=>"ent.iledefrance.fr",
                "port"=>"443",
                "contexte"=>"cas",
                "type"=>"monlycee",
            ],
        ];

        $this->db=array(
            'user'     => 'balado',     // Database username
            'password' => $dbpassword,  // Database password
            'host'     => $dbhost,      // Database host
            'name'     => 'balado',
            'port'     => $dbport,      // Database port
        );

    }

    public function getDB($key){
        return $this->db[$key];
    }

    public function getJWT($key){
        return $this->jwt[$key];
    }

    public function getServerName(){
        return $this->serverName;
    }

    public function getRestUrl(){
        return $this->restUrl;
    }

    public function getRestUrlOld(){
        return $this->restUrlOld;
    }

    public function getEtabUrl(){
        return $this->etabUrl;
    }
    
    public function getAppUrl(){
        return $this->appUrl;
    }

    public function getAcad(){
        return $this->acad;
    }

    public function getAcadByDep($dep){
        return $this->dep[$dep];
    }

    public function getCas($type){
        if(isset($this->cas[$type])) return $this->cas[$type];
        return false;
    }

    public function getMessageAlert($data){

        $messagemel="Nouveau message,\r\n";
        $messagemel.="message de : ".$data['mel']."\r\n";
        $messagemel.="RNE : ".$data['rne']."\r\n";
        $messagemel.="type : ".$data['type']."\r\n";
        $messagemel.="envoie de : ".$data['support']."\r\n";
        $messagemel.=$data['text']."\r\n";
        
        return  $messagemel;
    }

    public function getMessageInscription($activation){

        $messagemel="Bonjour,\r\n";
        $messagemel.="Votre inscription a bien été enregistrée.\r\n";
        $messagemel.="Pour activer votre compte vous devez cliquer sur le lien ci-dessous : \r\n";
        $messagemel.=$this->appUrl."#/app/activation/".$activation."\r\n";
        $messagemel.="Cordialement\r\n";
        $messagemel.="Administrateur Balado";
        return  $messagemel;
    }

    public function getMessageValideEtab($activation){

        $titre="Activation de votre compte Etablissement Balado";
        $messagemel="Bonjour,\r\n";
        $messagemel.="afin de valider la procédure d'activation du compte de votre établissement dans Balado, veuillez cliquer sur le lien ci-dessous :\r\n";
        $messagemel.=$this->etabUrl."#/app/activetab/".$activation."\r\n";
        $messagemel.="\r\n";
        $messagemel.="Cordialement\r\n";
        $messagemel.="L'administrateur de Balado";
        $messagemel=$messagemel;
        return $messagemel;
    }

    public function getMessageMelCe($rne,$activation){

            $titre="Accès Balado";
            $messagemel="Bonjour,\r\n";
            $messagemel.="le lien ci-dessous vous permet d'accéder au compte gestionnaire de votre établissement dans Balado afin d'importer les comptes enseignants ou élèves mais aussi de modifier la personne qui a la chage de gérer les comptes de Balado :\r\n";
            $messagemel.=$this->restUrl."authgest/".$rne."/".$activation."\r\n";
            $messagemel.="Ce lien est valable pendant deux heures.";
            $messagemel.="\r\n";
            $messagemel.="Cordialement\r\n";
            $messagemel.="L'administrateur de Balado";
            
            return  $messagemel;
    }

    public function getMessageMelProf($rne,$melprof,$etab){

            $titre="Accès Balado";
            $messagemel="Destinataire : ".$etab['Type']." ".$etab['Nom']." (".$etab['Ville'].")\r\n";
            $messagemel.="Bonjour,\r\n";

            $messagemel.="L'enseignant ".$melprof." souhaite utiliser l'application Balado mise à la disposition des enseignants et élèves par l'académie Créteil. \r\n";
            $messagemel.="Vous trouverez une présentation détaillée de l'application à cette adresse : https://balado.ac-creteil.fr/parallax \r\n";
            $messagemel.="Autorisez-vous la Dane de Créteil à procéder à la création des comptes, afin que Balado soit accessible dans l'ENT de votre établissement ? \r\n";
            $messagemel.=" \r\n";
    
            $messagemel.="Cordialement\r\n";
            $messagemel.="Jean-Marc Labat\r\n";
            $messagemel.="Administrateur de Balado";
            
            
            return  $messagemel;
    }

    public function getMessageNewMdp($activation){

            $titre="Gestion balado";
            $messagemel="Bonjour,\r\n";
            $messagemel.="afin de pouvoir gérer balado, veuillez cliquer sur le lien ci-dessous :\r\n";
            $messagemel.=$this->appUrl."#/app/mdp/".$activation."\r\n";
            $messagemel.="\r\n";
            $messagemel.="Cordialement\r\n";
            $messagemel.="L'administrateur de Balado";
            
            return  $messagemel;
    }

    public function getMessageValideGest($activation,$param=false){
                $messagemel="Bonjour,\r\n";
                $messagemel.="votre établissement dispose désormais d'un compte sur Balado.\r\n";
                $messagemel.="Vous avez été désigné par votre chef d'établissement pour en être le gestionnaire\r\n";
                $messagemel.="Cela implique essentiellement la création des comptes élèves et enseignants.\r\n";
                $messagemel.="Afin d'activer votre compte vous devez cliquer sur le lien ci-dessous :\r\n ";
                
                
                            
                //$lien=$this->etabUrl."#/app/activegest/".$activation;
                $lien=$this->getRestUrl()."validegest/".$activation;
                if($param){
                $lien=$this->getAppUrl()."#/app/inscription/".$param."/".$activation;
                }

                //$messagemel.=$chemin."/valideGest.php?activation=".$activationGest."&rne=".$rne;
                $messagemel.=$lien;
                $messagemel.="\r\n";
                $messagemel.="\r\n";
                $messagemel.="Cordialement\r\n";
                $messagemel.="L'administrateur de Balado";
                return  $messagemel;
    }

    public  function envoie_mel($mel, $titre,$message ) {
        if(strstr($mel,'@ac-creteil.fr')){
        $from="web.balado@ac-creteil.fr";
        }
        else{
        $from="admin@balado.ac-creteil.fr";
        }
        $statut=false;  
        $site="balado.ac-creteil.fr";
        $header  = "Reply-to: ".$from."\n";
        $header .= "From: ".$from."\n";
        $header .= "X-Sender: <".$site.">\n";
        $header .= "X-Mailer: PHP\n";
        $header .= "X-auth-smtp-user: ".$from." \n";
        $header .= "X-abuse-contact: ".$from." \n";
        $header .= "Date: ".date("D, j M Y G:i:s O")."\n";
        $header .= "MIME-Version: 1.0\n";
        $header.= "Content-Type: text/plain; ";
        $header .= "charset=\"UTF-8\"; ";
        $header .= "Content-Transfer-Encoding: 8bit;\n\n";
        $head="<!DOCTYPE HTML>";
        $head.="<html>";
        $head.="<head>";
        $head.="<meta charset='iso-8859-1'>";
        $head.="<title>".$titre."</title>";
        $head.="</head>";

        $head.="<body>";
        $foot="</body>";
        $foot.="</html>";
        
        if(mail($mel, $titre, $message,$header)){ 
    
        $statut=true;
        
        }
        return $statut;
    }
}
?>
